/*
 * And.java
 *
 * Created on February 18, 2002, 1:47 PM
 */

package org.semanticweb.dl;

import java.util.*;
import java.io.*;


/**
 * And = intersection.
 * @author  Michael Sintek
 * @version 
 */
public class And extends Expression {

  ArrayList _expressions; // of Expression
  
  /** Creates new And. */
  public And(ArrayList expressions) { // dont' call with empty list!
    _expressions = expressions;
  }
  
  public ArrayList getList() {
    return _expressions;
  }
  
  // static constructors, normalizing
  
  public static Expression getAnd(Expression expr) {
    if (expr instanceof And)
      return expr;
    else { // we should also normalize inner Ands
      ArrayList expressions = new ArrayList();
      expressions.add(expr);
     return new And(expressions);
    }
  }
  
  public static Expression getAnd(ArrayList list) {
    return getAnd(list, Symbol.BOTTOM);
  }
  
  public static Expression getAnd(ArrayList list, Expression def) {
    // def = default (usually TOP or BOTTOM)
    if (list.size() == 0)
      return def;
    else if (list.size() == 1)
      return (Expression)list.iterator().next();
    else
      return new And(list);
  }
    
  
  public void print(Syntax syntax, PrintWriter out) {
    if (syntax.XML()) {
      out.print("<AND>");
      printSequence(_expressions, syntax, out);
      out.print("</AND>");
    } else {
      out.print("(and ");
      printSequence(_expressions, syntax, out);
      out.print(")");
    }
  }
  
  public Expression toSHIQ(KB kb, int mode) {
    ArrayList list = new ArrayList();
    for (Iterator iter = _expressions.iterator(); iter.hasNext();)
      list.add(((Expression)iter.next()).toSHIQ(kb, CONCEPT));
    return getAnd(list);
  }

}
