/*
 * Defconcept.java
 *
 * Created on February 18, 2002, 9:30 AM
 */

package org.semanticweb.dl;

import java.util.*;
import java.io.*;


/**
 * The defconcept assertion.
 * @author  Michael Sintek
 * @version 
 */
public class Defconcept extends Assertion {

  Symbol _conceptSymbol;
  
  /** Creates new Defconcept */
  public Defconcept (Symbol symbol) {
    _conceptSymbol = symbol;
  }
  
  public Symbol getSymbol() {
    return _conceptSymbol;
  }
  
  public void print(Syntax syntax, PrintWriter out) {
    if (syntax.showDefconcept()) {
      if (syntax.XML()) {
        out.print("<DEFCONCEPT NAME=\"");
        _conceptSymbol.printSymbol(syntax, out);
        out.println("\"/>");
      } else if (syntax.DOT()) {
        List equals = ((DotSyntax)syntax).findEquals(_conceptSymbol);
	if (equals != null) { // null means this is not the representative!
	  out.print("\"");
	  _conceptSymbol.print(syntax, out);
	  out.print("\" [shape=record, label=\"{");
	  _conceptSymbol.print(syntax, out);
	  for (Iterator iter = equals.iterator(); iter.hasNext();) {
	    out.print("|");
	    ((Symbol)iter.next()).print(syntax, out);
	  }
	  out.println("}\"]");
	}
      } else {
        out.print("(defconcept ");
        _conceptSymbol.print(syntax, out);
        out.println(")");
      }
    }
  }
  
  public void toSHIQ(KB kb) {
    kb.add(new Defconcept((Symbol)_conceptSymbol.toSHIQ(kb, CONCEPT)));
  }
  
}
