/*
 * EqualR.java
 *
 * Created on February 18, 2002, 1:41 PM
 */
package org.semanticweb.dl;

import java.io.*;


/**
 * EqualR axiom (for roles).
 * @author  Michael Sintek
 * @version 
 */
public class EqualR extends Assertion {

  Expression _expr1, _expr2;
  
  /** Creates new EqualR */
  public EqualR(Expression expr1, Expression expr2) {
    _expr1 = expr1;
    _expr2 = expr2;
  }
  
  public void print (Syntax syntax, PrintWriter out) {
    if (syntax.XML ()) {
      out.print ("<EQUALR>");
      out.print ("<ROLE>");
      _expr1.print (syntax, out);
      out.print ("</ROLE>");
      out.print ("<ROLE>");
      _expr2.print (syntax, out);
      out.print ("</ROLE>");
      out.println ("</EQUALR>");
    } else {
      // out.print ("(" + syntax.EQUALR() + " ");
      out.print ("(equal_r ");
      _expr1.print (syntax, out);
      out.print (" ");
      _expr2.print (syntax, out);
      out.println (")");
    }
  }
  
  public void toSHIQ(KB kb) {
    kb.add(new EqualR(_expr1.toSHIQ(kb, ROLE), _expr2.toSHIQ(kb, ROLE)));
  }

}
