/*
 * Unambiguous.java
 *
 * Created on February 18, 2002, 5:10 PM
 */

package org.semanticweb.dl;

import java.io.*;


/**
 * Unambiguous assertion (for roles).
 * @author  Michel Sintek
 * @version 
 */
public class Unambiguous extends Assertion {

  Expression _expr;
  
  /** Creates new Unambiguous */
  public Unambiguous(Expression expr) {
    _expr = expr;
  }
  
  public void print(Syntax syntax, PrintWriter out) {
    if (syntax.XML ()) {
      out.print ("<UNAMBIGUOUS>");
      out.print ("<ROLE>");
      _expr.print (syntax, out);
      out.print ("</ROLE>");
      out.println ("</UNAMBIGUOUS>");
    } else {
      out.print ("(unambiguous ");
      _expr.print (syntax, out);
      out.println (")");
    }
  }
  
  public void toSHIQ(KB kb) {
    // (unambiguous r) -> (implies TOP (at-most 1 (inv r1)))
    kb.add(new Implies(Symbol.TOP,
      new AtMost(1, new Inverse(_expr.toSHIQ(kb, CONCEPT)))));
  }

}

