package org.semanticweb.glp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;

/**
 *  Title: Triple Description: RDF Query and Inference Language Copyright:
 *  Copyright (c) 2001 Company: Stanford University
 *
 *@author     Stefan Decker
 *@created    January 17, 2002
 *@version    1.0
 */

public class GLPForall extends GLPQuantifiedFormula {



    /**
     *  Constructor for the GLPForall object
     *
     *@param  v  Description of the Parameter
     *@param  f  Description of the Parameter
     */
    public GLPForall(ArrayList v, GLogicFormula f) {
        super(v,f);
    }


    /**
     *  Description of the Method
     *
     *@param  h  Description of the Parameter
     *@return    Description of the Return Value
     */
    public final GLogicFormula copyFormula(HashMap h) {
        HashMap h1 = (HashMap) h.clone();
        ArrayList newVarList = new ArrayList(6);
        for (int i = 0; i < v.size(); i++) {
            GLPTermVariable oldVariable = (GLPTermVariable) v.get(i);
            GLPTermVariable newVariable = VariableGenerator.getVariable(oldVariable);
            newVarList.add(newVariable);
            h1.put(oldVariable, newVariable);
        }
        return new GLPForall(newVarList, f.copyFormula(h1));
    }

    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        return toString("FORALL ", v, f);
    }
}
