/*
 * Servlet.java
 *
 * Created on March 6, 2002, 9:57 AM
 */

package org.semanticweb.triple.application;

import java.io.*;
import java.net.*;
import java.text.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;


public class Servlet extends HttpServlet {

  // CONFIGURE HERE
  final static String xsbProgram = "/U/sintek/bin/xsb";
  final static String xsbMemory = "16000"; // kb
  final static String logDir = "/U/sintek/ljava/tomcat/logs/triple/";
  // END CONFIGURE

  public void doPost(HttpServletRequest request, 
	HttpServletResponse response) throws IOException, ServletException {
    run(request, response);
  }

  public void doGet(HttpServletRequest request,
        HttpServletResponse response) throws IOException, ServletException {
    run(request, response);
  }

  public void run(HttpServletRequest request,
        HttpServletResponse response) throws IOException, ServletException {

    String timestamp = Long.toString(new Date().getTime());
    String tmpTripleFile = logDir + "triple" + timestamp + ".triple";
    String tmpXSBFile = logDir + "triple" + timestamp + ".P";

    String tripleProgram = request.getParameter("program");
    writeFile(tmpTripleFile, tripleProgram);

    // create html result page
    response.setContentType("text/html");
    PrintWriter htmlWriter = response.getWriter();
    htmlWriter.println("<html>");
    htmlWriter.println("<body text=#000000 bgcolor=#DCDCDC>");
    htmlWriter.println("<h2>Output From TRIPLE Engine</h2>");
    htmlWriter.println("<pre>");
    try {
      Commandline.compileTripleProgram(tmpTripleFile, tmpXSBFile, 
        logDir, timestamp, true); // true -> servlet mode
      String[] xsbCommand = new String[] { xsbProgram, "--noprompt", "--quiet",
        "-m", xsbMemory, "-e", "['" + tmpXSBFile + "']." };
      runExternalProgram(xsbCommand, htmlWriter, "halt.");
    } catch (Exception e) {
      htmlWriter.println("Error: " + e);
    }
    htmlWriter.println("</pre>");
    htmlWriter.println("<hr>");
    htmlWriter.println("<h2>TRIPLE Program</h2>");
    htmlWriter.println("<pre>");
    htmlWriter.println(tripleProgram);
    htmlWriter.println("</pre>");
    htmlWriter.println("</body>");
    htmlWriter.println("</html>");
  }


  // auxiliaries

  void writeFile(String fileName, String contents) {
    try {
      PrintWriter writer = new PrintWriter(new FileWriter(fileName));
      if (contents != null)
	writer.println(contents);
      writer.flush();
      writer.close();
    } catch (Exception e) { System.err.println(e); }
  }

  void runExternalProgram(String[] command, PrintWriter writer, 
      String sendString) throws Exception {
    Process process = Runtime.getRuntime().exec(command);
    PrintWriter outputStream = new PrintWriter(process.getOutputStream(), true);
    BufferedReader reader = 
      new BufferedReader(new InputStreamReader(process.getInputStream()));
    if (sendString != null)
      outputStream.println(sendString);
    outputStream.close(); // ??
    String line = reader.readLine();
    while (line != null) {
      writer.println(line);
      line = reader.readLine();
    }
  }

}

