package org.semanticweb.triple.inference;

/*
 *  Name: Atoms.java
 *  Version: 2.0
 *  Purpose: a container for atoms with appropriate access data structures
 *  (AVL trees)
 *  History:
 */
import java.io.*;
import java.util.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
class Filtering1 extends Operation {
    /**
     *  Constructor for the Filtering1 object
     *
     *@param  R1    Description of the Parameter
     *@param  ix1   Description of the Parameter
     *@param  R2    Description of the Parameter
     *@param  ix2   Description of the Parameter
     *@param  D     Description of the Parameter
     *@param  Time  Description of the Parameter
     */
    public Filtering1(Atoms R1, int ix1[], Atoms R2, int ix2[], Atoms D, long Time) {
        super(R1, ix1, R2, ix2, Time);
        this.D = D;
        D.tuples2 = null;
        comp1 = new CompareAtoms(ix1, ix2);
        comp2 = new CompareAtoms(ix2, ix1);
    }


    /**
     *  Description of the Method
     *
     *@param  t1  Description of the Parameter
     *@param  t2  Description of the Parameter
     */
    public void op(GroundAtom t1, GroundAtom t2) {
        GroundAtom ins;
        boolean res = true;
        GroundAtom f;
        int i;

        Atom t = (Atom) t1;

        res = t.Match(t2);
        t.ClearVariables();
        if (res) {
            f = new GroundAtom(D.arity);
            for (i = 0; i < D.arity; i++) {
                f.terms[i] = t2.terms[i];
            }
            ins = D.Insert(f);
        }
        if (t.lasttouched < timestamp) {
            t.next2 = R1.tuples2;
            R1.tuples2 = t;
            t.lasttouched = timestamp;
        }
        if (t2.lasttouched < timestamp) {
            t2.next2 = R2.tuples2;
            R2.tuples2 = t2;
            t2.lasttouched = timestamp;
        }
    }
}
