package org.semanticweb.triple.inference;

/*
 *  Name: StringTerm.java
 *  Version: 1.2
 *  Purpose: realises String terms
 *  History: function internalize1 returning a string added (jan)
 *  interface simplified (jan)
 */
import java.lang.String;
import java.io.*;
import java.util.*;
import java.net.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class StringTerm extends Term {
    // type = 3
    /**
     *  Description of the Field
     */
    public String s;

    // reprsentiert die Zeichenkette


    /**
     *  Constructor for the StringTerm object
     *
     *@param  st  Description of the Parameter
     */
    public StringTerm(String st) {
        // Stringkonstante
        super(new Term[0]);
        s = st;
    }


    /**
     *  Constructor for the StringTerm object
     *
     *@param  st     Description of the Parameter
     *@param  terms  Description of the Parameter
     */
    public StringTerm(String st, Term terms[]) {
        // Funktion mit String st als Funktionssymbol
        // terms enthaelt die Parameter
        super(terms);
        s = st;
    }


    /**
     *  Constructor for the StringTerm object
     *
     *@param  st       Description of the Parameter
     *@param  anzpars  Description of the Parameter
     *@param  grnd     Description of the Parameter
     */
    public StringTerm(String st, int anzpars, boolean grnd) {
        // Stringkonstante
        super(anzpars, grnd);
        s = st;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public Term CloneFlat() {
        return new StringTerm(s, pars.length, ground);
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    public int CompareFlat(Term t) {
        int res;
        // Vergleicht zwei Zeichenketten miteinander
        res = s.compareTo(((StringTerm) t).s);
        return res <= 0 ? (res < 0 ? -1 : 0) : 1;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String InternalizeFlat() {
        return "\"" + s + "\"";
    }


    /**
     *  Gets the stringTerm attribute of the StringTerm object
     *
     *@return    The stringTerm value
     */
    public boolean isStringTerm() {
        return true;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toStringFlat() {
        // Ausgabe des einzelnen StringTerms (ohne Unterterme) als Zeichenkette
        return "\"" + s + "\"";
    }


    /**
     *  Description of the Method
     *
     *@param  p   Description of the Parameter
     *@param  f   Description of the Parameter
     *@param  st  Description of the Parameter
     *@return     Description of the Return Value
     */
    public String toStringFlat(String p[], String f[], String st[]) {
        // Ausgabe des einzelnen StringTerms (ohne Unterterme) als Zeichenkette
        return "\"" + s + "\"";
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public int Type() {
        return 3;
    }
}
