package org.semanticweb.triple.inference.builtins;

/*
 *  Name: BuiltinConfig.java
 *  Version: 1.01
 *  Purpose:
 *  Configures Builtins. Builtins are introduced into the system
 *  by adding them to the list builtinList. New entries must(!) be added
 *  to the end of the list to keep old programs saved in the internal
 *  format running.
 *  History:
 *  7.5.99 Added support for new builtin mechanism. SDe
 */
import java.io.*;
import org.semanticweb.triple.inference.BuiltinFunc;
import org.semanticweb.triple.inference.SimpleEvaluator;
import org.semanticweb.triple.inference.Symbolhandler;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class BuiltinConfig {
    Builtin[] builtinList;


    /**
     *  Constructor for the BuiltinConfig object
     *
     *@param  eval  Description of the Parameter
     */
    public BuiltinConfig(SimpleEvaluator eval) {
        builtinList = eval.getSimpleEvaluatorConfig().getBuiltinList(eval);
    }


    /**
     *  Gets the builtinNumber attribute of the BuiltinConfig object
     *
     *@return    The builtinNumber value
     */
    public int getBuiltinNumber() {
        return builtinList.length;
    }


    /**
     *  Description of the Method
     *
     *@param  symbols  Description of the Parameter
     */
    public void init(Symbolhandler symbols) {
        int i = builtinList.length;
        for (int k = 0; k < i; k++) {
            symbols.searchAndInsertPredicateSymbols(builtinList[k].getSymbol(), builtinList[k].getArity());
        }
    }


    /**
     *  Description of the Method
     *
     *@param  symbol  Description of the Parameter
     *@return         Description of the Return Value
     */
    public BuiltinFunc newInstance(int symbol) {
        return builtinList[symbol].newInstance();
    }
}
