package org.semanticweb.utilities;
import java.util.Vector;

/**
 *  Title: Triple Description: RDF Query and Inference Language Copyright:
 *  Copyright (c) 2001 Company: Stanford University
 *
 *@author     Stefan Decker
 *@created    January 18, 2002
 *@version    1.0
 */

public class BinSearch {

    /**
     *  Description of the Method
     *
     *@param  s    Description of the Parameter
     *@param  x    Description of the Parameter
     *@param  cmp  Description of the Parameter
     *@return      Description of the Return Value
     */
    public static int binarySearch(Object s[], Object x, Comparator cmp) {
        int low = 0;
        int high = s.length - 1;
        int mid;
        int result;

        while (low <= high) {
            mid = (low + high) / 2;
            result = cmp.compare(s[mid], x);

            if (result < 0) {
                low = mid + 1;
            }
            else
                    if (result > 0) {
                high = mid - 1;
            }
            else {
                //System.out.println("Found it at " + new Integer(mid));
                return mid;
            }
        }
        return -1;
    }


    /**
     *  Description of the Method
     *
     *@param  v    Description of the Parameter
     *@param  x    Description of the Parameter
     *@param  cmp  Description of the Parameter
     *@return      Description of the Return Value
     */
    public static int binarySearch(Vector v, Object x, Comparator cmp) {
        int low = 0;
        int high = v.size() - 1;
        int mid;
        int result;

        while (low <= high) {
            mid = (low + high) / 2;
            result = cmp.compare(v.elementAt(mid), x);

            if (result < 0) {
                low = mid + 1;
            }
            else
                    if (result > 0) {
                high = mid - 1;
            }
            else {
                return mid;
            }
        }
        return -1;
    }

}
